// Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT.

package types

import (
	"fmt"
	"math/big"
)

// BigInt is a wrapper around big.Int that allows for JSON marshaling a big integer as a string.
type BigInt struct {
	big.Int
}

func (b BigInt) MarshalJSON() ([]byte, error) {
	return []byte(`"` + b.String() + `"`), nil
}

func (b *BigInt) UnmarshalJSON(p []byte) error {
	if string(p) == "null" {
		return nil
	}

	stringVal := string(p)
	if len(stringVal) > 2 && stringVal[0] == '"' && stringVal[len(stringVal)-1] == '"' {
		stringVal = stringVal[1 : len(stringVal)-1]
	}

	var z big.Int
	_, ok := z.SetString(string(stringVal), 10)
	if !ok {
		return fmt.Errorf("not a valid big integer: %s", p)
	}
	b.Int = z
	return nil
}

// MustBigIntFromString provides a helper function to return a big.Int from a string
// The string is assumed to be base 10 and if it is not a valid big.Int
// then the function will return nil
func MustBigIntFromString(s string) *BigInt {
	i, ok := new(big.Int).SetString(s, 10)
	if !ok {
		return nil
	}
	return &BigInt{
		Int: *i,
	}
}
